#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <pthread.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/types.h>
#include "wwork.h"
#include "wvarpi.h"
#include "warpi.h"
#include "types.h"

int setx;
int sety;

U16 startx;
U16 starty;
//предельные и средне значения кадра
U8  levmin; //мнимальное
U8  levmax; //маклсимальное
U8  levn;   //среднее
//
pthread_t               hWorkProcess;
pthread_mutex_t         WorkMutex;
int                     WorkWork;
//
U8  wvbuf[640][480];
//координаты начала региона
int strtxr;
int strtyr;
//размер региона
int szxr;
int szyr;
//шаг в регионе
int stepr;
U8  region[640][480];
//
U8  matrix1[640][480];
int mat1x1;
int mat1y1;
int mat1x2;
int mat1y2;
int mat1x3;
int mat1y3;
int mat1x4;
int mat1y4;


int StartWork(void)
{
    pthread_attr_t 	tattr;
    //параметры для отделяемых потоков
    pthread_attr_init(&tattr);
    pthread_attr_setdetachstate(&tattr, PTHREAD_CREATE_DETACHED);
    //
    //mutex create
    if(!(pthread_mutex_init(&WorkMutex,NULL) == 0))
        return 3;
    pthread_create(&hWorkProcess, &tattr, wWork_process, NULL);
    WorkWork = 1; //установка флага работы
    //
    return 0;
}

//подсчёт мин. сред. макс.
void wMathExtr(void)
{
    U8  ln;
    U8  lev;
    int lcntx = 0;
    int lcnty = 0;
    int sumlev = 0;
    levmin = 255;
    levmax = 0;
    while(lcnty < 480)
    {
        lcntx = 0;
        while(lcntx < 640)
        {
            lev = wvbuf[lcntx][lcnty];
            sumlev += lev;
            if(lev < levmin)
                levmin = lev;
            if(lev > levmax)
                levmax = lev;
            lcntx++;
        }
        lcnty++;
    }
    levn = sumlev /(640 * 480);
}

//заполнение элементов матрицы1
int fillMatrix1(float ferr, U16 sx, U16 sy)
{
    U8  err = (U8)((((((float)(levmax - levmin)) / 100.0) ) * ferr));
    U16 xl, xr;
    U16 yu, yd;
    U8  lev = wvbuf[sx][sy];
    //
    memset(&matrix1[0][0], 0, 640 * 480);
    matrix1[sx][sy] = _set_matrix_lev;
    yu  = sy;
    mat1x1 = 640;
    mat1x2 = 0;
    while(yu > 0)
    {
        xl = sx;
        while(xl > 0)
        {
            if((int)(err) < abs((int)(wvbuf[xl][yu]) - (int)(lev)))
                break;
            if(mat1x1 > xl)
                mat1x1 = xl;
            matrix1[xl][yu] = _set_matrix_lev;
            xl--;
        } 
        xr = sx;
        while(xr < 640)
        {
            if((int)(err) < abs((int)(wvbuf[xr][yu]) - (int)(lev)))
                break;
            if(mat1x2 < xr)
                mat1x2 = xr;
            matrix1[xr][yu] = _set_matrix_lev;
            xr++;
        }
        if((sx == xl) && (xr == sx))
            break;
        yu--;
    }
    mat1y1 = yu;
    mat1y2 = yu;
    yd  = sy;
    mat1x3 = 0;
    mat1x4 = 640;
    while(yd < 480)
    {
        xl = sx;
        while(xl > 0)
        {
            if((int)(err) < abs((int)(wvbuf[xl][yd]) - (int)(lev)))
                break;
            if(mat1x4 > xl)
                mat1x4 = xl;
            matrix1[xl][yd] = _set_matrix_lev;
            xl--;
        }
        xr = sx;
        while(xr < 640)
        {
            if((int)(err) < abs((int)(wvbuf[xr][yd]) - (int)(lev)))
                break;
            if(mat1x3 < xr)
                mat1x3 = xr;
            matrix1[xr][yd] = _set_matrix_lev;
            xr++;
        }
        if((sx == xl) && (xr == sx))
            break;
        yd++;
    }
    mat1y3 = yd;
    mat1y4 = yd;




    return 1;
}

//заполнение региона
void fillRegion(void)
{
    int cntx;
    int cnty    = strtyr;
    memset(&region[0][0], 0, 640 * 480);
    //X
    while(cnty < strtyr + szyr)
    {
        cntx    = strtxr;
        while(cntx < strtxr + szxr)
        {
            region[cntx][cnty] = _sint;
            cntx++;
        }
        cnty += stepr;
    }
    //Y
    cntx    = strtxr;
    while(cntx < strtxr + szxr)
    {
        cnty    = strtyr;
        while(cnty < strtyr + szyr)
        {
            region[cntx][cnty] = 32;
            cnty++;
        }
        cntx += stepr;
    }
}

//рабочий поток
void * wWork_process(void * pr)
{
    strtxr  = _strtxr;
    strtyr  = _strtyr;
    szxr  = _szxr;
    szyr  = _szyr;
    stepr = _stepr;
    //
    while(WorkWork)
    {
        pthread_mutex_lock(&WorkMutex);
        //
        wRdCam(&wvbuf[0][0]);
        wMathExtr();
        if((startx > 0) && (starty > 0))
        {
            fillMatrix1(5.0, startx,starty);
            startx = 0;
            starty = 0;
        }
        //
        pthread_mutex_unlock(&WorkMutex);
        usleep(_sleep_work);
    }
    pthread_exit(0);
}

//установка шага региона
int wSetStep(int st)
{
    pthread_mutex_lock(&WorkMutex);
    stepr = st;
    pthread_mutex_unlock(&WorkMutex);
    return 0;
}

//чтение региона
int wRdRegion(U8 * reg)
{
    pthread_mutex_lock(&WorkMutex);
    memcpy(reg, &region[0][0], 640 * 480);
    pthread_mutex_unlock(&WorkMutex);
    return 0;
}

//чтение первой матрицы
int wRdMatrix1(U8 * matr1)
{
    pthread_mutex_lock(&WorkMutex);
    memcpy(matr1, &matrix1[0][0], 640 * 480);
    pthread_mutex_unlock(&WorkMutex);
    return 0;
}

//старт заполнения матрицы1
int wStartMatrix1(U16 sx, U16 sy)
{
    pthread_mutex_lock(&WorkMutex);
    startx = sx;
    starty = sy;
    pthread_mutex_unlock(&WorkMutex);
    return 0;
}
